# Generated by Django 4.2.3 on 2023-07-30 09:23
"""Insert Region, Districts, Cantons to db"""
import os
import json

from django.db import migrations

from django.contrib.gis.geos import Polygon


def get_json_file_path(filename):
    json_data_dir = os.path.join(os.path.dirname(os.path.abspath(__file__)), '..', '..', 'json_data')
    file_path = os.path.join(json_data_dir, filename)
    return file_path


def create_regions(apps, schema_editor):
    Region = apps.get_model("geo", "Region")
    file_path = get_json_file_path("regions.json")
    with open(file_path, 'r') as file:
        data = json.load(file)
    for region in data:
        title = region["title"]
        geometry = Polygon(region["coordinates"][0])
        Region.objects.create(title=title, geometry=geometry)


def create_districts(apps, schema_editor):
    Region = apps.get_model("geo", "Region")
    District = apps.get_model("geo", "District")
    file_path = get_json_file_path("districts.json")
    with open(file_path, 'r') as file:
        data = json.load(file)
    for district in data:
        title = district["title"]
        geometry = Polygon(district["coordinates"][0])
        region = Region.objects.filter(title=district["region"]).first()
        District.objects.create(title=title, geometry=geometry, region_id=region.id)


def create_cantons(apps, schema_editor):
    District = apps.get_model("geo", "District")
    Canton = apps.get_model("geo", "Canton")
    file_path = get_json_file_path("cantons.json")
    with open(file_path, 'r') as file:
        data = json.load(file)
    for canton in data:
        title = canton["title"]
        geometry = Polygon(canton["coordinates"][0])
        district = District.objects.filter(title=canton["district"]).first()
        Canton.objects.create(title=title, geometry=geometry, district_id=district.id)


class Migration(migrations.Migration):
    dependencies = [
        ('geo', '0004_alter_canton_district_alter_contour_canton_and_more'),
    ]

    operations = [
        migrations.RunPython(create_regions, reverse_code=migrations.RunPython.noop),
        migrations.RunPython(create_districts, reverse_code=migrations.RunPython.noop),
        migrations.RunPython(create_cantons, reverse_code=migrations.RunPython.noop),
    ]
